//FW ver. 3.14 BetaTest

#include "Habits_NeoPixel.h"
#include <EEPROM.h>
#include <Bounce2.h>
#include <Wire.h>
#include <AT42QT2120.h>

const uint8_t isrPin = 2; // interrupt vector 0

AT42QT2120 qTouch;

#define PINRGB 9
#define PINW 10
#define SW 7
#define n_led 11

short status_led=n_led-1;

Habits_NeoPixel strip = Habits_NeoPixel(n_led, PINRGB, NEO_GRB + NEO_KHZ800); // 10 pixels WS2812 RGB //11

bool ledState = LOW;
bool oldState = LOW;
Bounce debouncer = Bounce(); 

bool A2DP=false;
bool AVRCP=false;
bool HFP=false;
bool TWS=false;
bool BLE=false;
bool SPP=false;

bool line_Done=0;
bool effectON=0;
bool mode=0;

#define MAX_NEC 20 // Maximum n° of commands for a presetted effects (Check MEM and buffer limits)

const boolean invert = false;

struct effectCMD // Data structure for each command recived for a presetted effect
{
  bool pixelsRGB[16];
  byte r;
  byte g;
  byte b;
  byte w;
  byte d;
  effectCMD() // Constructor
  {
    for(int i = 0;i < 16;i++)
    {
      pixelsRGB[i] = 0;
    }
    r = g = b = w = d = 0;
  }
}myPreset[MAX_NEC]; // Static declaration for maximum n° of commands for a presetted effects -> Need to be fixed

uint8_t RGBWDH[7] = {0,0,0,0,0,0,0}; // RED,GREEN,BLU,WHITE,DELAY,HRZ,VARIATION
uint8_t RGBDH_r[7] = {0,238,238,0,0,0,0};
uint8_t RGBDH_w[7] = {255,0x44,0,238,0,0,0};

uint8_t RGBWDH_old[7] = {0,0,0,238,0,0,0}; // RED,GREEN,BLU,WHITE,DELAY,HRZ,VARIATION
uint8_t W_old=0;


int8_t parserStatus = 0; // 0 Not connected - 1 Connected
int8_t effectStatus = 0; // 0 DUNNO LOL - 1 Static colour - 2 App effect - 3 Static effect
int8_t parserStatus_old = 0; // 0 Not connected - 1 Connected
int8_t effectStatus_old = 0; // 0 DUNNO LOL - 1 Static colour - 2 App effect - 3 Static effect
bool reloop = 0;
uint8_t n_PE = 0; // Step counter for a presetted effect
uint8_t N_PresetEffect = 0; // N° of commands recived for a presetted effect
unsigned long time; 

String MAC_BT_TWS;
uint8_t DIMMER = 238;
int8_t DIMMERINC=-17;

void setup()
{
  pinMode(13, OUTPUT); //MUTE (input or OUTPUT HIGH for forcing play)
  digitalWrite(13,LOW);
  
  pinMode(4, OUTPUT); //Route serial data (LOW -> BTmodule, HIGH -> USB )
  digitalWrite(4, LOW);
//  ledState=HIGH;
//  oldState=HIGH;
  pinMode(6, OUTPUT); //USB Phone charge (HIGH -> charge)
  digitalWrite(6, HIGH);
  
  pinMode(PINW, OUTPUT);
  setPwmFrequency(PINW, 256); //256
  
  Serial.begin(115200);
  Serial.setTimeout(10000);
  
  set_fst_bt_param();
  
  setup_touch();
  strip.begin();
  
//  strip.setPixelColor(status_led, strip.Color(0,0,255));
//  strip.show();
  
  pinMode(A1, OUTPUT); //STANDBY (input for read status, output LOW for forcing standby)
  digitalWrite(A1,HIGH);
  
  pinMode(A3, OUTPUT); //LineIN/BT (output LOW -> BT | HIGH -> LineIN)
  digitalWrite(A3,LOW);
  
  pinMode(3, OUTPUT); //AutoMANT (output HIGH for ON)
  digitalWrite(3, HIGH);
  
  pinMode(5, INPUT); //Audio Jack switch
  line_Done=digitalRead(5);
  
//  digitalWrite(4, HIGH); //LOW
//  digitalWrite(6, LOW); //LOW
  
  pinMode(SW, INPUT); //Switch ProgMODE (input LOW > 5sec -> ProgMODE)
  debouncer.attach(SW);
  debouncer.interval(500);
  
  pinMode(A2, OUTPUT); //Line in / out
  digitalWrite(A2, LOW);
  
  pinMode(13, INPUT); //MUTE (input or OUTPUT HIGH for forcing play)
  //digitalWrite(13,HIGH);
  if(ledState==LOW)
  {
    ledState=HIGH;
    oldState=HIGH;
    setOperate(); 
  }
}

void setProg()
{
         digitalWrite(6, LOW);
         delay(1000);
         digitalWrite(4, HIGH);
         colorWipe(0);
         strip.setPixelColor(status_led, strip.Color(0,255,0));
         strip.setPixelColor(status_led-1, strip.Color(255,0,0));
         digitalWrite(PINW, LOW);
         strip.show();         
         delay(100);
         
         colorWipe(0);
         strip.show();
         delay(100);
         
         strip.setPixelColor(status_led, strip.Color(0,0,0));
         strip.setPixelColor(status_led-1, strip.Color(0,0,0));
         strip.show();         
         delay(100);
         
         colorWipe(0);
         strip.show();
         delay(100);
         
         strip.setPixelColor(status_led, strip.Color(0,255,0));
         strip.setPixelColor(status_led-1, strip.Color(255,0,0));
         strip.show();
         Serial.flush();
}
void setOperate()
{
         digitalWrite(4, LOW);
         delay(1000);
         digitalWrite(6, HIGH);
         reset_BC127();
         colorWipe(0);
         strip.setPixelColor(status_led, strip.Color(0,0,0));
         strip.show();
         Serial.flush();
}

void read_SW()
{

  // Update the Bounce instance :
   debouncer.update();
   
   // Call code if Bounce fell (transition from HIGH to LOW) :
   if ( debouncer.fell() )
   {     
     // Toggle LED state :
     ledState = !ledState;
     if(ledState!=oldState)
     {
       if(ledState==LOW)
       {
         knownStart();
         stdCmd("UNPAIR");
         delay(100);
         setProg();        
       }
       else
       {
         setOperate(); 
       }
       oldState=ledState;
     }
   }
}

void setPwmFrequency(int pin, int divisor) {
  byte mode;
  if(pin == 5 || pin == 6 || pin == 9 || pin == 10) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 64: mode = 0x03; break;
      case 256: mode = 0x04; break;
      case 1024: mode = 0x05; break;
      default: return;
    }
    if(pin == 5 || pin == 6) {
      TCCR0B = TCCR0B & 0b11111000 | mode;
    } else {
      TCCR1B = TCCR1B & 0b11111000 | mode;
    }
  } else if(pin == 3 || pin == 11) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 32: mode = 0x03; break;
      case 64: mode = 0x04; break;
      case 128: mode = 0x05; break;
      case 256: mode = 0x06; break;
      case 1024: mode = 0x07; break;
      default: return;
    }
    TCCR2B = TCCR2B & 0b11111000 | mode;
  }
}

void loop()
{    
  caploop();
  read_SW();
  readLineIN();
  if(ledState==1)
  {
    parser();
    if(parserStatus==1)
    {
      reloop=1;
      if(effectStatus == 3 && effectON==1)
      {
        execPresetEffect();
      }
      if(effectStatus == 2 && effectON==1)
      {
        execAppEffect();
      }
    }
    else
    {
//      if(reloop==1)
//      {
//        reloop=0;
//      }
//      caploop();
//      if(mode==0)
//      {
//        RGBWDH[0]=0;RGBWDH[1]=0;RGBWDH[2]=0;RGBWDH[3]=dimmerw*onoff;
//        staticShow();
//      }
//      if(mode==1)
//      {      
//        RGBWDH[0]=R*onoff;RGBWDH[1]=G*onoff;RGBWDH[2]=B*onoff;RGBWDH[3]=0;
//        staticShow(); 
//      }
    }  
  }  
}

void set_fst_bt_param() //addr 0x00 for BT module name, addr 0x05 for sensors direction
{
  short temp = EEPROM.read(0x00);
  if(temp != 0x22)  //Set BT module name and blink led
  {
//    Serial.begin(115200); //9600
//    delay(500);
    setOperate();
//    delay(1000);
//    Serial.flush();

//    stdCmd("BAUD=115200");
//    stdCmd("WRITE");
//    reset_BC127();
//    Serial.end();
//    Serial.begin(115200);
//    delay(1000);
    Serial.flush();
    delay(500);
    Serial.print("SET AUTOCONN=1\r");
    delay(500);
    Serial.print("SET CLASSIC_ROLE=0 2\r");
    delay(500);
    Serial.print("SET ENABLE_SPP=OFF\r");
    delay(500);
    Serial.print("SET ENABLE_BATT_IND=OFF\r");
    delay(500);
    Serial.print("SET ENABLE_LED=OFF\r");
    delay(500);
    Serial.print("WRITE\r");
    delay(500);
    reset_BC127();
//    Serial.end();  
    EEPROM.write(0x00, 0x22); //0x07 for never do it again
    digitalWrite(PINW, HIGH);
    delay(200);
    digitalWrite(PINW, LOW);
    delay(200);
    digitalWrite(PINW, HIGH);
    delay(200);
    digitalWrite(PINW, LOW);
    setProg();
  }
  delay(10);
}

void readLineIN()
{
  if(digitalRead(5)==LOW && line_Done==0)
  {
    digitalWrite(A3,HIGH);
    stdCmd("PIO 3 1");
    line_Done=1;
    
  }
  if(digitalRead(5)==HIGH && line_Done==1)
  {
    digitalWrite(A3,LOW);
    line_Done=0;
  }
}
