// Execute a single command of a presetted effect
void execPresetEffect()
{
  while(Serial.available() == 0 && (((qTouch.getRegValue(AT42QT2120::DETECTIONSTATUS))& AT42QT2120::WHEELBIT)==0)&& qTouch.getRegValue(AT42QT2120::KEYSTATUS)==0)
  {
    for(int j = 0;j < 10;j++)
    {
      if(myPreset[n_PE].pixelsRGB[j] == HIGH)
      {
        strip.setPixelColor(j,strip.Color(myPreset[n_PE].r, myPreset[n_PE].g, myPreset[n_PE].b)); // Fill the marked dots with the color presetted
      }    
    }
    if(myPreset[n_PE].pixelsRGB[10] == HIGH) // If 11th bit HIGH write the effect otherwise sum the effect with the previous
    {
      analogWrite(PINW, myPreset[n_PE].w);
      strip.show();
      time = millis(); 
      while((millis() < (time + (map(myPreset[n_PE].d,0,255,0,5000)))) && Serial.available() == 0 && (((qTouch.getRegValue(AT42QT2120::DETECTIONSTATUS))& AT42QT2120::WHEELBIT)==0)&& qTouch.getRegValue(AT42QT2120::KEYSTATUS)==0) // Wait for the last presetted time (mapped within 5 seconds) or until a new serial data is present
      {}
      colorWipe(strip.Color(0,0,0)); // Tourn off all the RGB LEDs before loading the next commands
    }
    n_PE++;
    if(n_PE >= N_PresetEffect) // It makes sure that it cycles on the commands received for the effect
    {
      n_PE = 0;
    }
  }
}


// Execute the effect personalized by the user within the app
void execAppEffect()
{
  uint8_t rc = RGBWDH[0];
  uint8_t gc = RGBWDH[1];
  uint8_t bc = RGBWDH[2];
  int8_t ri=1;
  int8_t gi=1;
  int8_t bi=1;
  
  bool h = HIGH;
  
  unsigned long timeh = millis();
  unsigned long timed = millis();
  
  while(Serial.available() == 0 && (((qTouch.getRegValue(AT42QT2120::DETECTIONSTATUS))& AT42QT2120::WHEELBIT)==0)&& qTouch.getRegValue(AT42QT2120::KEYSTATUS)==0)
  {
  	if(rc > 254 || rc > (RGBWDH[0] +(RGBWDH[6] / 2))&&(!Serial.available())) 
  	  ri = -1;
  	if(rc < 1 || rc < (RGBWDH[0] - (RGBWDH[6] / 2))&&(!Serial.available()))
  	  ri = 1;
  
  	if(gc > 254 || gc > (RGBWDH[1] +(RGBWDH[6] / 2))&&(!Serial.available())) 
  	  gi= - 1;
  	if(gc < 1 || gc < (RGBWDH[1] -(RGBWDH[6] / 2))&&(!Serial.available()))
  	  gi = 1;
  
  	if(bc > 254 || bc > (RGBWDH[2] +(RGBWDH[6] / 2))&&(!Serial.available())) 
  	  bi = -1;
  	if(bc < 1 || bc < (RGBWDH[2] -(RGBWDH[6] / 2))&&(!Serial.available()))
  	  bi = 1;
  
  	if(RGBWDH[5] < 0xFE && millis() > (timeh + (map(RGBWDH[5],0,253,1000,0)))&&(!Serial.available()))
  	{
  	  h = !h;
  	  timeh = millis();
  	}
  
  	if(millis() > (timed + (map(RGBWDH[4],0,253,0,100)))&&(!Serial.available()))
  	{
  	  rc = rc + ri;
  	  gc = gc + gi;
  	  bc = bc + bi;
  	  timed = millis();
  	}
  	
      colorWipe(strip.Color(rc * h, gc * h, bc * h));
      strip.show();
      analogWrite(PINW, (RGBWDH[3] * h));
  }
}
