// Decode and mark the pixels that are to be modified
void setPixel(char data_a, char data_b, bool *seq) 
{
  uint8_t i;
  for (byte mask = 00000001, i = 0; mask > 0; mask <<= 1, i++)
  {
    if (data_a & mask)
    {
      seq[i] = true;
    }else{
      seq[i] = false;
    }
    if (data_b & mask)
    {
      seq[i+8] = true;
    }else{
      seq[i+8] = false;
    }
  }
}

// Show the ongoing static effect
void staticShow()
{
  colorWipe(strip.Color((RGBWDH[0]*DIMMER)/255,(RGBWDH[1]*DIMMER)/255,(RGBWDH[2]*DIMMER)/255));
  strip.show();
  analogWrite(PINW, (RGBWDH[3]*DIMMER)/255);
}


// Fill the dots one after the other with a color
void colorWipe(uint32_t c) {
  for(uint8_t i = 0; i < (strip.numPixels()-1); i++) {
      strip.setPixelColor(i, c);
  }
}

// Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, c);
      strip.show();
      delay(wait);
  }
}

void hueToRGB(int hue, int brightness)
{
    unsigned int scaledHue = (hue * 6);
    // segment 0 to 5 around the color wheel
    unsigned int segment = scaledHue / 256;
    // position within the segment 
    unsigned int segmentOffset = scaledHue - (segment * 256); 

    unsigned int complement = 0;
    unsigned int prev = (brightness * ( 255 -  segmentOffset)) / 256;
    unsigned int next = (brightness *  segmentOffset) / 256;
    if(invert)
    {
      brightness = 255-brightness;
      complement = 255;
      prev = 255-prev;
      next = 255-next;
    }

    switch(segment) {
    case 0:    // red
    RGBWDH[0] = brightness;
    RGBWDH[1] = next;
    RGBWDH[2] = complement;
    break;
    case 1:    // yellow
    RGBWDH[0] = prev;
    RGBWDH[1] = brightness;
    RGBWDH[2] = complement;
    break;
    case 2:    // green
    RGBWDH[0] = complement;
    RGBWDH[1] = brightness;
    RGBWDH[2] = next;
    break;
    case 3:    // cyan
    RGBWDH[0] = complement;
    RGBWDH[1] = prev;
    RGBWDH[2] = brightness;
    break;
    case 4:    // blue
    RGBWDH[0] = next;
    RGBWDH[1] = complement;
    RGBWDH[2] = brightness;
    break;
    case 5:    // magenta
    default:
    RGBWDH[0] = brightness;
    RGBWDH[1] = complement;
    RGBWDH[2] = prev;
    break;
    }
    RGBDH_r[0]=RGBWDH[0];RGBDH_r[1]=RGBWDH[1];RGBDH_r[2]=RGBWDH[2];
}
